<template>
  <!--Video de fond -->

<div class="intro">
  <div class="video">
    <video class="video_media" src="assets/hourglass.mp4" autoplay muted loop></video>
  </div>

  <div class="intro_content">
    <div id="app">
      <div class="container">
        <div class="row">
          <div class="col"></div>
          <div class="col">
            <div class="text-center mt-3 text-white h4">Timer app</div>
            <div class="text-center mt-3 text-white h1 display-2"><strong>

              <!--Timer component -->
              <Timer
                  :timer="formattedTime"
                  :state="timerState"
                  @start="start"
                  @pause="pause"
                  @stop="stop"
              ></Timer>
              <!--Timer component -->
            </strong>
            </div>
          </div>
        </div>
      </div>
    </div>
    </div>
  </div>
</template>

<script>
import Timer from '@/components/Timer';

export default {
  name: 'App',
  components: {
    Timer
  },
  data () {
    return {
      timerState: 'stopped',
      currentTimer: 0,
      formattedTime: "00:00:00",
      ticker: undefined,
    }
  },
  methods: {
    start () {
      //console.log("Start");
      if (this.timerState !== 'running') {
        this.tick();
        this.timerState = 'running';
      }
    },
    pause () {
      window.clearInterval(this.ticker);
      this.timerState = 'paused';
    },
    stop () {
      window.clearInterval(this.ticker);
      this.currentTimer = 0;
      this.formattedTime = "00:00:00";
      this.timerState = "stopped";
    },
    tick: function () {
      this.ticker = setInterval(() => {
        this.currentTimer++;
        this.formattedTime = this.formatTime(this.currentTimer);
      }, 250)
    },
    formatTime(seconds) {
      let measurredTime = new Date(null);
      measurredTime.setSeconds(seconds);
      let MMSTime = measurredTime.toISOString().substr(11, 8);
      return MMSTime;
    }
  }
}

</script>


<style>
.intro {
  max-height: 100vh;
  overflow: hidden;
  position: relative;
  background: url("assets/time.jpg") center no-repeat; /* ajouter une photo*/
  background-size: cover;
}

.intro_content {
  display: flex;
  flex-direction: column;
  justify-content: center;
  width: 100%;
  height: 100%;
  position: absolute;
  top: 0;
  left: 0;
  z-index: 3;
}

.video {
  position: relative;
  z-index: 1;
  padding-bottom: 56.25%;
}

.video_media {
  width: 100%;
  height: auto;
  position: absolute;
  top: 0;
  left: 0;
}

</style>
